var cfg = require('../cfg/irc.json');
var fs = require('fs-extra');
var mysql = require('mysql');
var bot = require('coffea')();
var Lib = require('./lib.js');
var Websrv = require('./websrv.js');

var sql;
var haDC = () => {
  sql = mysql.createConnection(require('../cfg/mysql.json'));
  sql.connect((err) => {
    if(err) setTimeout(haDC, 2000);
  });
  sql.on('error', (err) => {
    if(err.code === 'PROTOCOL_CONNECTION_LOST') haDC();
  });
};
haDC();

var lib = new Lib(bot, sql);
var websrv = new Websrv(bot, sql, lib);

cfg.forEach((e,i,a) => {
  bot.add({
    "name": e.name,
    "host": e.host,
    "port": e.port,
    "ssl": e.ssl,
    "ssl_allow_invalid": e.ssl_allow_invalid,
    "pass": e.pass,
    "nick": e.nick,
    "username": e.username,
    "realname": e.realname
  });
  console.log("Server "+e.name+" wurde geladen");
});

bot.on('motd', (e) => {
  console.log("motd von "+e.network+" erhalten");
  bot.mode(bot.me, "+B", e.network);
});

bot.on('message', (e) => {
  lib.trigger.trigger.forEach((entry,i,a) => {
    if(e.message.match(entry.call) && entry.active == 1) {
      lib.log('trigger: '+entry.name);
      lib.getUserlevel(e.user.getNick(), e.network, e.channel.getName(), (cb) => {
        if(cb.level >= entry.level)
          entry.func(e, cb.level);
        else
          e.reply('no permission, min level '+entry.level+' required');
      });
    }
  });
});